/// <reference types="socket.io-client" />
/// <reference types="es6-promise" />
export declare type ReturnFunction = (returnedValue: any, thrownException: any) => any;
export declare type CodeFunction = (returnMethod: ReturnFunction, args: any[]) => void;
export declare type EventFunction = (...args: any[]) => void;
export interface SioRpcClientConnectionStatusListener {
    onConnectionStatusChange(status: boolean): void;
}
export declare class SioRpcClient {
    socket: SocketIOClient.Socket;
    constructor(url: string, connectionStatusListener?: SioRpcClientConnectionStatusListener);
    call(methodName: string, ...args: any[]): Promise<any>;
    subscribe(eventName: string, eventCode: EventFunction): void;
    subscribeOnce(eventName: string, eventCode: EventFunction): void;
}
