"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ioclient = require('socket.io-client');
var es6_promise_1 = require('es6-promise');
var RemoteError = (function (_super) {
    __extends(RemoteError, _super);
    function RemoteError(thrownException) {
        _super.call(this, thrownException.message);
        this.name = thrownException.remote_name;
        this.message = thrownException.remote_message;
        this.stack = thrownException.remote_stack;
    }
    return RemoteError;
}(Error));
var SioRpcClient = (function () {
    function SioRpcClient(url, connectionStatusListener) {
        this.socket = ioclient.connect(url);
        if (typeof connectionStatusListener !== 'undefined') {
            this.socket.on('disconnect', function () {
                connectionStatusListener.onConnectionStatusChange(false);
            });
            this.socket.on('connect', function () {
                connectionStatusListener.onConnectionStatusChange(true);
            });
        }
    }
    SioRpcClient.prototype.call = function (methodName) {
        var _this = this;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return new es6_promise_1.Promise(function (resolve, reject) {
            _this.socket.emit('call', [methodName].concat(args), function (returnedValueAndThrownException) {
                if (typeof returnedValueAndThrownException.thrownException !== 'undefined') {
                    return reject(new RemoteError(returnedValueAndThrownException.thrownException));
                }
                resolve(returnedValueAndThrownException.returnedValue);
            });
        });
    };
    SioRpcClient.prototype.subscribe = function (eventName, eventCode) {
        this.socket.on(eventName, function (args) {
            eventCode.apply(null, args);
        });
    };
    SioRpcClient.prototype.subscribeOnce = function (eventName, eventCode) {
        this.socket.once(eventName, function (args) {
            eventCode.apply(null, args);
        });
    };
    return SioRpcClient;
}());
exports.SioRpcClient = SioRpcClient;
//# sourceMappingURL=main.js.map