"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const http = require('http');
const main_1 = require('./main');
(function main() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const server = http.createServer();
            const port = 42080;
            server.listen(port, () => __awaiter(this, void 0, void 0, function* () {
                try {
                    const rpcServer = new main_1.SioRpcServer(server);
                    rpcServer.declare('com.sqreept.siorpc.remoteAdd', (firstTerm, secondTerm) => firstTerm + secondTerm);
                    rpcServer.declare('com.sqreept.siorpc.remoteAddAsync', (firstTerm, secondTerm) => {
                        return new Promise((resolve, reject) => {
                            setTimeout(() => reject(new RangeError('Random error')), 1000);
                        });
                    });
                    rpcServer.run();
                    const rpcClient = new main_1.SioRpcClient(`http://localhost:${port}`);
                    const value1 = yield rpcClient.call('com.sqreept.siorpc.remoteAdd', 34, 6);
                    console.log('value1: ', value1);
                    const value2 = yield rpcClient.call('com.sqreept.siorpc.remoteAddAsync', 34, 8);
                    console.log('value2: ', value2);
                    rpcClient.subscribe('com.sqreept.siorpc.onLowMemory', (freeRam) => {
                        console.log('freeRam: ', freeRam);
                    });
                    rpcServer.publish('com.sqreept.siorpc.onLowMemory', 3096);
                }
                catch (e) {
                    console.error(e.stack);
                    process.exit(1);
                }
            }));
        }
        catch (e) {
            console.error(e.stack);
            process.exit(1);
        }
    });
}());
//# sourceMappingURL=test.js.map